(function ($, Drupal, drupalSettings) {
  'use strict';

  Drupal.behaviors.Kanban = {
    attach: function attach(context) {
      $('.views-view-kaban', context).once('Kanban').each(function () {
        let kanbanHeight = $('.views-view-kaban').height();
        $('.panel-body [droppable=true]').css('min-height', (kanbanHeight - 180) + 'px');
        draggableInit();
      });

      function draggableInit() {
        let entityId, type;

        $('.views-view-kaban [draggable=true]').bind('dragstart', function (event) {
          entityId = $(this).data('id');
          type = $(this).data('type');
          event.originalEvent.dataTransfer.setData("text/plain", event.target.getAttribute('id'));
        });

        $('.views-view-kaban .panel-body').bind('dragover', function (event) {
          $(this).addClass('bg-info');
          event.preventDefault();
        });
        $('.views-view-kaban .panel-body').bind('dragleave', function () {
          $(this).removeClass('bg-info');
        });

        $('.views-view-kaban [droppable=true]').bind('drop', function (event) {
          let view_kanban = $(this).closest('.views-view-kaban');
          let view_id = view_kanban.data('view_id');
          let display_id = view_kanban.data('display_id');
          let stateValue = $(this).data('value');
          let spinners = '<div class="spinners d-flex justify-content-center">' +
            '<div class="spinner-border" role="status">' +
            '<span class="sr-only">Loading...</span>' +
            '</div>' +
            '</div>';
          if (entityId != stateValue) {

            let elementId = event.originalEvent.dataTransfer.getData("text/plain");

            $(this).prepend(spinners);
            //before post
            if (type && entityId && stateValue) {
              // Generate URL for AJAX call.
              const url = Drupal.url('views-kanban/update-state/' + view_id + '/' + display_id + '/' + entityId + '/' + stateValue);
              let that = $(this);
              $.ajax({
                'url': url,
                'success': function (result) {
                  let article = $('#' + elementId).detach();
                  that.prepend(article);
                  that.parent().removeClass('bg-info');
                  that.find('.spinners').remove();
                },
                'error': function (xhr, status, error) {
                  alert(Drupal.t('An error occurred during the update of the desired node. Please consult the watchdog.'));
                }
              });
            }

          }

          event.preventDefault();
        });
      }

    }
  };
})(jQuery, Drupal, drupalSettings);
